%%%%%%%%%%%%% Phase Images %%%%%%%%%%%%%%%
if TWF==1  %% for three curves
figure(11), subplot(2,1,1), semilogx(KAPPA_set(1:s_KAPPA),RMSE_phi_TWF_set,'ok-'),hold on, grid on,...  %% wrap phase
semilogx(KAPPA_set(1:s_KAPPA),RMSE_phi_GS(:,end),'og-'), title('RMSE PHASE'),...
semilogx(KAPPA_set(1:s_KAPPA),RMSE_phi(:,end),'or-'), hold on,...
 ylabel('RMSE'),...
    hleg1 = legend('TWF','GS','SPAR');
subplot(2,1,2), semilogx(KAPPA_set(1:s_KAPPA),RMSE_ampl_TWF_set,'ok-'),hold on, grid on,...
semilogx(KAPPA_set(1:s_KAPPA),RMSE_ampl_GS(:,end),'og-'), title('RMSE AMPL'),...
semilogx(KAPPA_set(1:s_KAPPA),RMSE_ampl(:,end),'or-'), hold on,...
xlabel('\chi'), ylabel('RMSE'),...
hleg1 = legend('TWF','GS','SPAR');
else                %% only two curves
     figure(11), subplot(2,1,1), semilogx(KAPPA_set(1:s_KAPPA),RMSE_phi_GS(:,end),'og-'), title('RMSE PHASE'), hold on, grid on,...
semilogx(KAPPA_set(1:s_KAPPA),RMSE_phi(:,end),'or-'), hold on,title('RMSE PHASE'),...
 ylabel('RMSE'),...
hleg1 = legend('GS','SPAR');
subplot(2,1,2), semilogx(KAPPA_set(1:s_KAPPA),RMSE_ampl_GS(:,end),'og-'), title('RMSE AMPL'),hold on, grid on,...
semilogx(KAPPA_set(1:s_KAPPA),RMSE_ampl(:,end),'or-'), hold on,...
xlabel('\chi'), ylabel('RMSE'),...
hleg1 = legend('GS','SPAR');
end

if unwrapping==1
    
% figure(22), subplot(1,2,1), surfl(varphi); grid on,VV=axis; shading interp;colormap(gray);   title(['TRUE ABS PHASE']),...
% subplot(1,2,2), axis(VV);surfl(double(phi_u0_SPAR+bb)); shading interp;colormap(gray); title(['SPAR , RMSE_{ABS PHASE}=', num2str(RMSE_phi(end,end),3)])


if TWF==1

phi_Uo_TWF=puma_ho(angle(x_hat),.5,'verbose',verbose); %% for demo unwrapping from raw data
bb_TWF=mean(varphi(:) - phi_Uo_TWF(:));
RMSE_phi_TWF = norm(varphi - phi_Uo_TWF-bb_TWF, 'fro')/sqrt(yN*xN); % EMSE Initial rel. phase error

phi_Uo_GS=puma_ho(angle(V_GS),.5,'verbose',verbose); %% for demo unwrapping from raw data
bb_GS=mean(varphi(:) - phi_Uo_GS(:));
RMSE_phi_GS_abs = norm(varphi - phi_Uo_GS-bb_GS, 'fro')/sqrt(yN*xN); % EMSE Initial rel. phase error


figure, subplot(1,4,4), surfl(varphi); VV=axis; shading interp;colormap(gray);   title(['TRUE ABS PHASE'])


subplot(1,4,1),  surfl(double(phi_Uo_TWF+bb_TWF));axis(VV); shading interp;colormap(gray); title(['TWF , RMSE_{ABS PHASE}=', num2str(RMSE_phi_TWF,3),' , \chi =',num2str(KAPPA,3) ]),...

subplot(1,4,2), ;surfl(double(phi_Uo_GS+bb_GS));axis(VV); shading interp;colormap(gray); title(['GS , RMSE_{ABS PHASE}=', num2str(RMSE_phi_GS_abs,3)])
subplot(1,4,3), surfl(double(phi_u0_SPAR+bb));axis(VV); shading interp;colormap(gray); title(['SPAR , RMSE_{ABS PHASE}=', num2str(RMSE_phi(s_KAPPA,end),3)])





end
end



% figure, imshow(angle(V_GS)+bb1_GS,[]), title(['GS phase, \chi =  ', num2str(KAPPA)])
% 
% 
% 
% figure, imshow(angle(x_hat),[]), title(['TWF phase, \chi =  ', num2str(KAPPA)]) 
% % figure, imshow(phi_Uo,[]), title('phi-Uo')
% figure, imshow(angle(V)+bb1,[]), title(['SPAR phase, \chi =  ', num2str(KAPPA)]) 


% figure, semilogx(KAPPA_set,SNR,'o'), hold on, semilogx(KAPPA_set,SNR,'o'), semilogx(KAPPA_set,SNR), title('SNR'), grid on
% figure, loglog(KAPPA_set,Number_Photons_per_Pixel,'o'), hold on, loglog(KAPPA_set,Number_Photons_per_Pixel), ...
%     grid on, title('Number-Photons-per-Pixel'),
%%%%%%%%%%% Amplitude Images %%%%%%%%%%%%%%%%%


if 0
figure, imshow(abs(V_GS),[]), title('GS ampl')
figure, imshow(abs(x_hat),[]), title('TWF ampl')
% figure, imshow(phi_Uo,[]), title('phi-Uo')
figure, imshow(abs(V),[]), title('SPAR ampl ')
end